$RHTTPClient::version = "0.1";
$RHTTPClient::versiondate = "20081023";

$RHTTPClient::AsciiTable = "\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3a\x3b\x3c\x3d\x3e\x3f\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\x4a\x4b\x4c\x4d\x4e\x4f\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\x5a\x5b\x5c\x5d\x5e\x5f\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\x7a\x7b\x7c\x7d\x7e\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7\xa8\xa9\xaa\xab\xac\xad\xae\xaf\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7\xe8\xe9\xea\xeb\xec\xed\xee\xef\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff";
$RHTTPClient::HexTable = "0123456789abcdef";

function RHTTPClientTCP::onLine(%this, %line)
{
//	echo("RHTTPClient::onLine: state=[" @ %this.parent.state @
//		"] line=[" @ %line @ "]");
	if (%this.parent.state == 3) {
		%line = nextToken(%line, httptag, " ");
		%line = nextToken(%line, httpcode, " ");

		%this.parent.httptag = %httptag;
		%this.parent.httpcode = %httpcode;
		%this.parent.response = %line;
		// FIXME: result code handling (esp. 301/302)
		%this.parent.state = 4;

		if (%this.parent.callbackState !$= "")
			call(%this.parent.callbackState, %this.parent);
	} else if (%this.parent.state == 4) {
		if (%line $= "") {
			%this.parent.state = 5;

			if (%this.parent.callbackState !$= "")
				call(%this.parent.callbackState, %this.parent);
		} else {
			%line = nextToken(%line, headername, ":");
			// skip whitespace
			while (getSubStr(%line, 0, 1) $= " ")
				%line = getSubStr(%line, 1, strlen(%line) - 1);
//			echo("HEADER: [" @ %headername @ "] [" @ %line @ "]");
			%this.parent.header[%headername] = %line;
		}
	} else if (%this.parent.state == 5) {
//		echo("BODY: [" @ %line @ "]");

		if (%this.parent.body $= "")
			%this.parent.body = %line;
		else
			%this.parent.body = %this.parent.body @ "\n" @ %line;

		if (%this.parent.callbackLine !$= "")
			call(%this.parent.callbackLine, %this.parent, %line);
	}
}

function RHTTPClientTCP::onDNSResolved(%this)
{
	%this.parent.state = 1;
	if (%this.parent.callbackState !$= "")
		call(%this.parent.callbackState, %this.parent);
}

function RHTTPClientTCP::onDNSFailed(%this)
{
	// FIXME: not triggered?
	%this.parent.state = 8;

	if (%this.parent.callbackState !$= "")
		call(%this.parent.callbackState, %this.parent);
}

function RHTTPClientTCP::onConnectRequest(%this)
{
	// FIXME: not triggered?
	%this.parent.state = 2;

	if (%this.parent.callbackState !$= "")
		call(%this.parent.callbackState, %this.parent);
}

function RHTTPClientTCP::onConnectFailed(%this)
{
	%this.parent.state = 9;

	if (%this.parent.callbackState !$= "")
		call(%this.parent.callbackState, %this.parent);
	if (%parent.callbackError !$= "")
		call(%parent.callbackError, %parent);
}

function RHTTPClientTCP::onConnected(%this)
{
	%parent = %this.parent;

	%parent.setHeader("User-Agent", %parent.userAgent);
	%parent.setHeader("Host", %parent.host);

	for (%x = 1; %x <= %parent.varCount; %x++) {
		if (%varstring !$= "")
			%varstring = %varstring @ "&";
		%varstring = %varstring @
			RHTTPClient::urlencode(%parent.vars[%x, "key"]) @ "=" @
			RHTTPClient::urlencode(%parent.vars[%x, "value"]);
	}

	if (%parent.requestType $= "GET") {
		// get query vars
		if (%varstring !$= "")
			%getquery = "?" @ %varstring;
	} else if (%parent.requestType $= "POST") {
		// get post vars
		%parent.setHeader("Content-Length", strlen(%varstring));
		%parent.setHeader("Content-Type", "application/x-www-form-urlencoded; charset=iso8859-1");
	}
		
	// FIXME: support chunked encoding (and therefore HTTP/1.1?)
	%query = %parent.requestType SPC %parent.path @ %getquery SPC "HTTP/1.0\r\n";
	for (%x = 1; %x <= %parent.headerCount; %x++) {
		%query = %query @ %parent.headers[%x, "key"] @
			": " @ %parent.headers[%x, "value"] @
			"\r\n";
	}
	%query = %query @ "\r\n";
	if (%parent.requestType $= "POST")
		%query = %query @ %varstring;
//	echo("Sending HTTP request:\n" @ %query);
//	echo("HTTP variables: " @ %varstring);
	%this.send(%query);

	%parent.state = 3;

	if (%parent.callbackState !$= "")
		call(%parent.callbackState, %parent);
}

function RHTTPClientTCP::onDisconnect(%this)
{
	%parent = %this.parent;
	
	if (%parent.state == 5) {
		if (%parent.httpcode >= 400 && %parent.httpcode <= 599)
			call(%parent.callbackError, %parent);
	}

	%this.disconnect();

	if (%parent.state == 5) {
		%parent.state = 6;
		if (%parent.callbackDone !$= "")
			call(%parent.callbackDone, %parent);
	} else {
		if (%parent.callbackError !$= "")
			call(%parent.callbackError, %parent);
	}

	if (%parent.callbackState !$= "")
		call(%parent.callbackState, %parent);
}

function RHTTPClient::send(%this, %requestType, %host, %path)
{
	%port = nextToken(%host, host, ":");

	%this.host = %host;
	%this.port = (%port $= "") ? 80 : %port;
	%this.path = %path;
	%this.requestType = %requestType;
	
	%this.tcp.connect(%this.host @ ":" @ %this.port);
}

function RHTTPClient::setHeader(%this, %key, %value)
{
	for (%x = 1; %x <= %this.headerCount; %x++) {
		if (%this.headers[%x, "key"] $= %key) {
			%this.headers[%x, "value"] = %value;
			return;
		}
	}

	%this.headerCount++;

	%this.headers[%this.headerCount, "key"] = %key;
	%this.headers[%this.headerCount, "value"] = %value;
}

function RHTTPClient::setVar(%this, %key, %value)
{
	for (%x = 1; %x <= %this.varCount; %x++) {
		if (%this.vars[%x, "key"] $= %key) {
			%this.vars[%x, "value"] = %value;
			return;
		}
	}

	%this.varCount++;

	%this.vars[%this.varCount, "key"] = %key;
	%this.vars[%this.varCount, "value"] = %value;
}

function RHTTPClient::setCallbackState(%this, %func)
{
	%this.callbackState = %func;
}

function RHTTPClient::setCallbackDone(%this, %func)
{
	%this.callbackDone = %func;
}

function RHTTPClient::setCallbackError(%this, %func)
{
	%this.callbackError = %func;
}

function RHTTPClient::setCallbackLine(%this, %func)
{
	%this.callbackLine = %func;
}

function RHTTPClient::create()
{
	%versionString = "RHTTPClient/" @ $RHTTPClient::version SPC "(" @ $RHTTPClient::versiondate @ ")";

	%newclient = new scriptObject() {
		class = RHTTPClient;
		state = 0;
		headerCount = 0;
		userAgent = "Tribes2/" @ getT2VersionNumber() SPC %versionString;
		body = "";
	};

	%newclient.reset();

	return %newclient;
}

function RHTTPClient::reset(%this)
{
	%this.state = 0;
	%this.body = "";

	for (%x = 1; %x <= %this.headerCount; %x++) {
		%this.headers[%x, "key"] = "";
		%this.headers[%x, "value"] = "";
	}
	%this.headerCount = 0;
	for (%x = 1; %x <= %this.varCount; %x++) {
		%this.vars[%x, "key"] = "";
		%this.vars[%x, "value"] = "";
	}
	%this.varCount = 0;

	if (!isObject(%this.tcp)) {
		%this.tcp = new TCPObject(RHTTPClientTCP);
		%this.tcp.parent = %this;
	}
}

function RHTTPClient::destroy(%this)
{
	%this.reset();
	if (isObject(%this.tcp))
		%this.tcp.delete();
	// FIXME: this randomly fails
	%this.delete();
}

function RHTTPClient::ascii(%char)
{
	%char = getSubStr(%char, 0, 1);

	return strstr($RHTTPClient::AsciiTable, %char) + 1;
}

// FIXME: support negative numbers?
function RHTTPClient::dectohex(%dec, %pad)
{
	while (%dec > 0) {
		%out = getSubStr($RHTTPClient::HexTable, %dec % 16, 1) @ %out;
		%dec = mFloor(%dec / 16);
	}
	
	while (strlen(%out) < %pad)
		%out = "0" @ %out;
	
	return %out;
}

function RHTTPClient::urlencode(%in)
{
	%len = strlen(%in);

	for (%x = 0; %x < %len; %x++) {
		%char = getSubStr(%in, %x, 1);
		%asc = RHTTPClient::ascii(%char);
		if (%asc == 0x20)
			%out = %out @ "+";
		else if (%asc < 0x30 || %asc > 0x7f)
			%out = %out @ "%" @ RHTTPClient::dectohex(%asc, 2);
		else
			%out = %out @ %char;
	}

	return %out;
}
